function [y,bw] = erbspace(flow,fhigh,n)
%-*- texinfo -*-
%@deftypefn {Function} erbspace
%@verbatim
%ERBSPACE  Equidistantly spaced points on erbscale
%   Usage: y=erbspace(flow,fhigh,n);
%
%   This is a wrapper around AUDSPACE that selects the erb-scale. Please
%   see the help on AUDSPACE for more information.
%
%@end verbatim
%@strong{Url}: @url{http://ltfat.sourceforge.net/doc/auditory/erbspace.php}
%@seealso{audspace, freqtoaud}
%@end deftypefn

% Copyright (C) 2005-2014 Peter L. Soendergaard <soender@users.sourceforge.net>.
% This file is part of LTFAT version 1.4.4
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

%   AUTHOR : Peter L. Soendergaard
  
[y,bw] = audspace(flow,fhigh,n,'erb');


