function a = maxTreeSub(wt)
%-*- texinfo -*-
%@deftypefn {Function} maxTreeSub
%@verbatim
%MAXTREESUB
%@end verbatim
%@strong{Url}: @url{http://ltfat.sourceforge.net/doc/wavelets/wfbtmanip/maxTreeSub.php}
%@end deftypefn

% Copyright (C) 2005-2014 Peter L. Soendergaard <soender@users.sourceforge.net>.
% This file is part of LTFAT version 1.4.4
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

% All nodes with at least one final output.
termN = find(noOfNodeOutputs(1:numel(wt.nodes),wt)~=0);
% Range in filter outputs
outRangeTermN = rangeInLocalOutputs(termN,wt);

% Subsampling factors of the terminal nodes
subTermN = nodeSub(termN,wt);

a = [];
for ii=1:numel(termN)
   a = [a; subTermN{ii}(outRangeTermN{ii})];
end

a = max(a);
